/************************************************************************/
/*BEGINPROLOGUE************************************************************************
 * @copyright(disclaimer)                                                             *
 * Licensed Materials - Property of IBM                                               *
 * IBM Enterprise Information Portal for Multiplatforms V8.1 (program number 5724-B43)*
 * (c ) Copyright IBM Corp. 1998,  2002. All Rights Reserved.                         *
 *                                                                                    *
 * US Government Users Restricted Rights                                              *
 * Use, duplication or disclosure restricted by GSA ADP Schedule                      *
 * Contract with IBM Corp.                                                            *
 *                                                                                    *
 * DISCLAIMER OF WARRANTIES :                                                         *
 *                                                                                    *
 * Permission is granted to copy and modify this Sample code, and to                  *
 * distribute modified versions provided that both the copyright                      *
 * notice,- and this permission notice and warranty disclaimer appear in all copies   * 
 * and modified versions.                                                             *
 *                                                                                    *
 * THIS SAMPLE CODE IS LICENSED TO YOU AS-IS.                                         *
 * IBM AND ITS SUPPLIERS AND LICENSORS DISCLAIM ALL WARRANTIES, EITHER EXPRESS OR     *
 * IMPLIED, IN SUCH SAMPLE CODE, INCLUDING THE WARRANTY OF NON-INFRINGEMENT AND THE   *
 * IMPLIED WARRANTIES OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. IN NO   *
 * EVENT WILL IBM OR ITS LICENSORS OR SUPPLIERS BE LIABLE FOR ANY DAMAGES ARISING OUT *
 * OF THE USE OF OR INABILITY TO USE THE SAMPLE CODE, DISTRIBUTION OF THE SAMPLE CODE,*
 * OR COMBINATION OF THE SAMPLE CODE WITH ANY OTHER CODE. IN NO EVENT SHALL IBM OR ITS*
 * LICENSORS AND SUPPLIERS BE LIABLE FOR ANY LOST REVENUE, LOST PROFITS OR DATA, OR   *
 * FOR DIRECT, INDIRECT, SPECIAL, CONSEQUENTIAL,INCIDENTAL OR PUNITIVE DAMAGES,       *
 * HOWEVER CAUSED AND REGARDLESS OF THE THEORY OF LIABILITY,-, EVEN IF IBM OR ITS     *
 * LICENSORS OR SUPPLIERS HAVE BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.       *
 *                                                                                    *
 * @endCopyright                                                                      *
 **************************************************************************************/
/************************************************************************/
/*
 * Filename       : TxdoChgSmsDL.java
 * Description    : test the xdo for change the part collection (storage management)
 * setup:  1. bring up SMS server
 *         2. bring up System Admin Client
 *         3. create migration policy(managementClass) MEIMGT1 with
 *            retension period = 30 days & storage calss = FIXED
 *         4. create workstation collection CBR.MEICOLLECT1 with
 *            migration policy = MEIMGT1 & storage group = GROUP01
 *         5. pick a known itemId from sample loader's output log &
 *            pick a added partId (added with default collectname CBR.CLLCT001)
 *
 * hard code: need to modify library server/userid/password for dsDL.connect    
 * invoke: TxdoChgSmsDL <partId> <repType> <itemId>
 *
 */

#include <iostream.h>
#include <stdio.h>  
#include <stdlib.h>
#include <DKString.hpp>

#include <DKConstantDL.h>
#include <DKDatastoreDL.hpp>
#include <DKException.hpp>
#include <DKBlobDL.hpp>
#include <DKSearchEngineInfoDL.hpp>
#include <DKAnnotationDL.hpp>
#include <DKMediaStreamInfoDL.hpp>
#include <DKStorageManageInfoDL.hpp>
#include <DKEnvironment.hpp>

void main(int argc, char *argv[])
{
   cout << "begin..." << endl;
   // Indicate this is a Console Application on Windows NT/95 for error
   // message code page conversion to OEM code page. If this was a Windows
   // GUI (Graphic User Interface) Application this would not be necessary
   // because DK_SS_WINDOWS is the default.
   DKEnvironment::setSubSystem(DK_SS_CONSOLE);
     
    DKDatastoreDL dsDL;
    DKString itemId, repType;
    int partId;
    partId = 5;
    repType = "FRN$NULL";  
    itemId = "P5ZJ4YKMS0KLT711";
    
    cout <<"argc is "<<argc<<endl;
    if (argc == 1)
    {
      cout<<"invoke: TxdoChgSmsDL <partId> <repType> <itemId>"<<endl;
      cout<<" no parameter, following default will be provided:"<<endl;
      cout<<"The supplied default partId = "<<partId<<endl;
      cout<<"The supplied default repType = "<<repType<<endl;
      cout<<"The supplied default itemId = "<<itemId<<endl;
    }
    else if (argc == 2)
    {
      partId = atoi(argv[1]);
      cout<<"you enter: TxdoChgSmsDL "<<argv[1]<<endl;
      cout<<"The supplied default repType = "<<repType<<endl;
      cout<<"The supplied default itemId = "<<itemId<<endl;
    }
    else if (argc == 3)
    {
     repType = DKString(argv[2]);
     partId = atoi(argv[1]);
     cout<<"you enter: TxdoChgSmsDLL "<<argv[1]<<" "<<argv[2]<<endl;
     cout<<"The supplied default itemId = "<<itemId<<endl;
    }
    else if (argc == 4)
    {
     itemId = DKString(argv[3]);
     repType = DKString(argv[2]);
     partId = atoi(argv[1]);
     cout<<"you enter: TxdoChgSmsDL "<<argv[1]<<" "<<argv[2]<<" "<<argv[3]<<endl;
    }

    cout << "Connecting to datastore...." << endl;
    try {
     dsDL.connect("LIBSRVRP","FRNADMIN","PASSWORD");
     cout << "datastore connected" << endl;   
   
     DKBlobDL* axdo = new DKBlobDL(&dsDL);
     DKPidXDODL*  apid = new DKPidXDODL;
     apid ->setPartId(partId);
     apid->setPrimaryId(itemId);
     axdo ->setPidObject(apid);
     cout <<"itemId= " << axdo->getItemId()<<endl;
     cout<<"partId="<<((DKPidXDODL*)(axdo->getPidObject()))->getPartId()<<endl;

     //---set SMS -----
     DKStorageManageInfoDL aSMS;
     aSMS.setRetention(555);
     aSMS.setCollectionName("CBR.MEICOLLECT1");
     aSMS.setManagementClass("MEIMGT1");
     aSMS.setStorageClass("FIXED");
     axdo->setExtension("DKStorageManageInfoDL", (dkExtension*)&aSMS);

     cout <<"about to do changeStorage()"<<endl;
     axdo->changeStorage();
     cout <<"changeStorage() success..."<<endl;

     cout<<"about to retrieve/open() the changedSMS object..."<<endl;
     axdo ->retrieve(); 
     int concls = axdo->getContentClass();
     if (concls == DK_DL_CC_ASCII)
	axdo->setInstanceOpenHandler("notepad", TRUE);
     else if (concls == DK_DL_CC_GIF)
        axdo->setInstanceOpenHandler("lviewpro", TRUE);  //use lviewpro in NT
     else if (concls == DK_DL_CC_AVI)
  	axdo->setInstanceOpenHandler("mplay32", TRUE);
     axdo ->open();

     cout <<" length of lobdata = "<<axdo->length()<<endl;
     cout <<" mimeType = "<<axdo->getMimeType()<<endl;
     cout <<" size of lobdata = "<<axdo->getSize()<<endl;
     cout<<" createdTimestamp="<<axdo->getCreatedTimestamp()<<endl;
     cout<<" updatedTimestamp="<<axdo->getUpdatedTimestamp()<<endl;

     int atype = axdo->getAffiliatedType();
       cout <<"affiliatedType= "<<axdo->getAffiliatedType()<<endl;
       if (atype == DK_DL_ANNOTATION)
       {
        DKAnnotationDL* ann = (DKAnnotationDL*)axdo->getExtension("DKAnnotationDL");
	cout<<"  getName="<<ann->getName()<<endl;
        cout<<"  pageNumber= "<<ann->getPageNumber()<<endl;
        cout<<"  partId="<<ann->getPart()<<endl;
        cout<<"  X= "<<ann->getX()<<endl;
        cout<<"  Y= "<<ann->getY()<<endl;
       }

       cout <<"about to retrieve the DKStorageManageInfoDL ...."<<endl; 
       DKStorageManageInfoDL* sms =  (DKStorageManageInfoDL*)axdo->getExtension("DKStorageManageInfoDL");
        cout<<"  collectionName= "<<sms->getCollectionName()<<endl;
        cout<<"  managementClass="<<sms->getManagementClass()<<endl;
        cout<<"  storageClass="<<sms->getStorageClass()<<endl;
        cout<<"  retention="<<sms->getRetention()<<endl;
        cout<<"  storeSite="<<sms->getStoreSite()<<endl;

     delete axdo;
     delete apid;
     dsDL.disconnect();
     cout<<"datastore disconnected"<<endl;
    }
    catch(DKException &exc)
    {
      cout << "Error id" << exc.errorId() << endl;
      cout << "Exception id " << exc.exceptionId() << endl;
      for(unsigned long i = 0; i< exc.textCount();i++)
      {
       cout << "Error text:" << exc.text(i) << endl;
      }
      for (unsigned long g=0; g< exc.locationCount();g++)
      {
       const DKExceptionLocation* p = exc.locationAtIndex(g);
       cout << "Filename: " << p->fileName() << endl;
       cout << "Function: " << p->functionName() << endl;
       cout << "LineNumber: " << p->lineNumber() << endl;
      }
      cout << "Exception Class Name: " << exc.name() << endl;
    }   
    cout << "done ..." << endl;      
}


