/*BEGINPROLOGUE************************************************************************
 * @copyright(disclaimer)                                                             *
 * Licensed Materials - Property of IBM                                               *
 * IBM Information Integrator for Content V8.2  (program number 5724-B43)             *
 * (c ) Copyright IBM Corp. 1998, 2002, 2003. All Rights Reserved.                    *
 *                                                                                    *
 * US Government Users Restricted Rights                                              *
 * Use, duplication or disclosure restricted by GSA ADP Schedule                      *
 * Contract with IBM Corp.                                                            *
 *                                                                                    *
 * DISCLAIMER OF WARRANTIES :                                                         *
 *                                                                                    *
 * Permission is granted to copy and modify this Sample code, and to                  *
 * distribute modified versions provided that both the copyright                      *
 * notice,- and this permission notice and warranty disclaimer appear in all copies   * 
 * and modified versions.                                                             *
 *                                                                                    *
 * THIS SAMPLE CODE IS LICENSED TO YOU AS-IS.                                         *
 * IBM AND ITS SUPPLIERS AND LICENSORS DISCLAIM ALL WARRANTIES, EITHER EXPRESS OR     *
 * IMPLIED, IN SUCH SAMPLE CODE, INCLUDING THE WARRANTY OF NON-INFRINGEMENT AND THE   *
 * IMPLIED WARRANTIES OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. IN NO   *
 * EVENT WILL IBM OR ITS LICENSORS OR SUPPLIERS BE LIABLE FOR ANY DAMAGES ARISING OUT *
 * OF THE USE OF OR INABILITY TO USE THE SAMPLE CODE, DISTRIBUTION OF THE SAMPLE CODE,*
 * OR COMBINATION OF THE SAMPLE CODE WITH ANY OTHER CODE. IN NO EVENT SHALL IBM OR ITS*
 * LICENSORS AND SUPPLIERS BE LIABLE FOR ANY LOST REVENUE, LOST PROFITS OR DATA, OR   *
 * FOR DIRECT, INDIRECT, SPECIAL, CONSEQUENTIAL,INCIDENTAL OR PUNITIVE DAMAGES,       *
 * HOWEVER CAUSED AND REGARDLESS OF THE THEORY OF LIABILITY,-, EVEN IF IBM OR ITS     *
 * LICENSORS OR SUPPLIERS HAVE BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.       *
 *                                                                                    *
 * @endCopyright                                                                      *
 **************************************************************************************

  *** All documentation provided within the corresponding .cpp file. ***
  
    Please refer to the corresponding .cpp file for all documentation.

    All functions provided are static functions and do not require the object to be
    instanciated.

****************************************************************************************/
#ifndef _SCONNECTDISCONNECTICM_HPP_
#define _SCONNECTDISCONNECTICM_HPP_

    // Includes / Imports
    #include <DKDatastoreICM.hpp>

    // Declaration
    class SConnectDisconnectICM{
    public:

        //-------------------------------------------------------------------
        // Sample Program
        //-------------------------------------------------------------------
        // All funcitons provided are static functions and do not require the 
        // object to be instantiated.
        static int main(int argc, char *argv[]);

        //-------------------------------------------------------------------
    	// Wrapper Function Prototypes
        //-------------------------------------------------------------------
        // The following are wrapper functions for functionality covered
        // in this sample.  These functions may be used by other samples.
        static DKDatastoreICM* connect        (char * database, char * userName, char * password, char * connectionOptions);
        static void            disconnect     (dkDatastore * datastore);
	    static void            printException (DKException &exc);
    };

    //-------------------------------------------------------------------
    // Global Constants
    //-------------------------------------------------------------------
    // Public Constants for Defaults Used by Samples
    #define SConnectDisconnectICM_DEFAULT_DATABASE "icmnlsdb"
    #define SConnectDisconnectICM_DEFAULT_USERNAME "icmadmin"
    #define SConnectDisconnectICM_DEFAULT_PASSWORD "password"
    
    #define SConnectDisconnectICM_EIP_VERSION      "8.2"
    
    // Value returned from main to indicate that an error or exception has ocurred.
    #define SConnectDisconnectICM_RC_SAMPLE_FAILED -1
    // Value returned from main to indicate that no exceptions were thrown during operation.
    #define SConnectDisconnectICM_RC_SAMPLE_PASSED 0 

#endif
