/*BEGINPROLOGUE************************************************************************
 * @copyright(disclaimer)                                                             *
 * Licensed Materials - Property of IBM                                               *
 * IBM Enterprise Information Portal for Multiplatforms V8.1 (program number 5724-B43)*
 * (c ) Copyright IBM Corp. 1998,  2002. All Rights Reserved.                         *
 *                                                                                    *
 * US Government Users Restricted Rights                                              *
 * Use, duplication or disclosure restricted by GSA ADP Schedule                      *
 * Contract with IBM Corp.                                                            *
 *                                                                                    *
 * DISCLAIMER OF WARRANTIES :                                                         *
 *                                                                                    *
 * Permission is granted to copy and modify this Sample code, and to                  *
 * distribute modified versions provided that both the copyright                      *
 * notice,- and this permission notice and warranty disclaimer appear in all copies   * 
 * and modified versions.                                                             *
 *                                                                                    *
 * THIS SAMPLE CODE IS LICENSED TO YOU AS-IS.                                         *
 * IBM AND ITS SUPPLIERS AND LICENSORS DISCLAIM ALL WARRANTIES, EITHER EXPRESS OR     *
 * IMPLIED, IN SUCH SAMPLE CODE, INCLUDING THE WARRANTY OF NON-INFRINGEMENT AND THE   *
 * IMPLIED WARRANTIES OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. IN NO   *
 * EVENT WILL IBM OR ITS LICENSORS OR SUPPLIERS BE LIABLE FOR ANY DAMAGES ARISING OUT *
 * OF THE USE OF OR INABILITY TO USE THE SAMPLE CODE, DISTRIBUTION OF THE SAMPLE CODE,*
 * OR COMBINATION OF THE SAMPLE CODE WITH ANY OTHER CODE. IN NO EVENT SHALL IBM OR ITS*
 * LICENSORS AND SUPPLIERS BE LIABLE FOR ANY LOST REVENUE, LOST PROFITS OR DATA, OR   *
 * FOR DIRECT, INDIRECT, SPECIAL, CONSEQUENTIAL,INCIDENTAL OR PUNITIVE DAMAGES,       *
 * HOWEVER CAUSED AND REGARDLESS OF THE THEORY OF LIABILITY,-, EVEN IF IBM OR ITS     *
 * LICENSORS OR SUPPLIERS HAVE BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.       *
 *                                                                                    *
 * @endCopyright                                                                      *
 **************************************************************************************/

/*
 * Filename       : TAddXDODL.java
 * Description    : this sample requires you to know the existing itemId 
 *                  in the library. 
 *                  Specify the itemId, partId & fileName that you wish to add
 *                  Specify no parameters to see different ways to call this
 *                  sample to add a text part that to that you wish to be
 *                  indexed by Text Search or add an image part
 *                  that you wish to be indexed by QBIC.
 *
 */

import com.ibm.mm.sdk.server.*;
import com.ibm.mm.sdk.common.*;
import java.io.*;
import java.lang.*;

public class TAddXDODL 
implements DKConstantDL
{

    // Main method
    public static void main(String[] args)
    {
        String  fileName = "";
        String  itemId =       "G8DHN$JESHHJKAOE";
        String libsrv = "";
        String userid = "";
        String pw = "";
        String strPartId;
        int partId = 22;
        String srchSrv = "";
        String srchIndex = "";
        String qbicSrv = "";
        String qbicDB = "";
        String qbicCat = "";
        String searchEngine = "";
        String searchIndex = "";
        String searchInfo = "";
        boolean fText = false;
        boolean fQBIC = false;

        if (args.length == 8)
        {
            libsrv = args[0];
            userid = args[1]; 
            pw = args[2];
            partId = (int)Integer.parseInt(args[3], 10);
            strPartId = args[3];
            fileName = args[4];
            qbicSrv = args[5];
            qbicDB = args[6];
            qbicCat = args[7];
            System.out.println("You enter: java TAddXDODL " +
                               libsrv + " " + userid +
                               " " + strPartId + " " + fileName + " " + qbicSrv + " " + qbicDB +
                               " " + qbicCat);
            fQBIC = true;
            searchEngine = "QBIC";
            searchInfo = "ENU";
            searchIndex = qbicDB + "-" + qbicCat + "-" + qbicSrv;
        } else if (args.length == 7)
        {
            libsrv = args[0];
            userid = args[1]; 
            pw = args[2];
            partId = (int)Integer.parseInt(args[3], 10);
            strPartId = args[3];
            fileName = args[4];
            srchSrv = args[5];
            srchIndex = args[6];
            System.out.println("You enter: java TAddXDODL " +
                               libsrv + " " + userid +
                               " " + strPartId + " " + fileName + " " + srchSrv + " " + srchIndex);
            fText = true;
            searchEngine = "SM";
            searchInfo = "ENU";
            searchIndex = srchSrv + "-" + srchIndex;
        } else if (args.length == 5)
        {
            libsrv = args[0];
            userid = args[1]; 
            pw = args[2];
            partId = (int)Integer.parseInt(args[3], 10);
            strPartId = args[3];
            fileName = args[4];
            System.out.println("You enter: java TAddXDODL " +
                               libsrv + " " + userid +
                               " " + strPartId + " " + fileName );
        } else
        {
            System.out.println("To add a part");
            System.out.println("Invoke: java TAddXDODL <libsrv> <userid> <pw> <partId> <filename>");
            System.out.println("                  or ");
            System.out.println("To add a part indexed by TS");
            System.out.println("Invoke: java TAddXDODL <libsrv> <userid> <pw> <partId> <filename> <TextSrv> <TextSrchIndex>");
            System.out.println("                  or ");
            System.out.println("To add a part indexed by QBIC");
            System.out.println("Invoke: java TAddXDODL <libsrv> <userid> <pw> <partId> <filename> <QBICSrv> <QBICDB> <QBICCAT>");
            return;
        }
        DKDatastoreDL dsDL = null;
        DKDatastoreTS dsTS = null;
        DKDatastoreQBIC dsQBIC = null;
        try
        {
            DKDatastoreDefTS dsDefTS = null;
            DKDatastoreAdminTS dsAdminTS = null;
            DKSearchIndexDefTS pIndx = null;
            dsDL = new DKDatastoreDL();

            System.out.println("connecting to datastore"); 
            dsDL.connect(libsrv,userid,pw,"");

            System.out.println("datastore DL connected"); 

            if (fText == true)
            {
                System.out.println("verify TS datastore"); 
                dsTS = new DKDatastoreTS();
                dsTS.connect(srchSrv,"","","");
                System.out.println("datastore TS connected"); 
                dsDefTS = (DKDatastoreDefTS)dsTS.datastoreDef();
                dsAdminTS = (DKDatastoreAdminTS)dsDefTS.datastoreAdmin();
                System.out.println("get search index"); 
                pIndx = (DKSearchIndexDefTS)dsDefTS.getEntity(srchIndex);
                System.out.println("got search index"); 
            }

            if (fQBIC == true)
            {
                System.out.println("verify QBIC datastore"); 
                dsQBIC = new DKDatastoreQBIC();
                dsQBIC.connect(qbicSrv,userid,pw,"");
                System.out.println("datastore QBIC connected");
                dsQBIC.openCatalog(qbicDB, qbicCat);
                System.out.println("Catalog opened ");
                dsQBIC.closeCatalog();
                System.out.println("Catalog closed");
                dsQBIC.disconnect();
                System.out.println("datastore QBIC disconnected"); 
                dsQBIC.destroy();
            }

            DKBlobDL axdo = new DKBlobDL(dsDL);
            DKPidXDODL  apid = new DKPidXDODL();
            apid.setPartId(partId);
            apid.setPrimaryId(itemId);
            axdo.setPidObject(apid);
            axdo.setContentClass(DK_CC_ASCII);
            axdo.setContentFromClientFile(fileName);
            System.out.println("lobData len= " + axdo.length());

            // indexing
            if (fText == true || fQBIC == true)
            {
                System.out.println("part is to be indexed ");
                DKSearchEngineInfoDL aSrchEx = new DKSearchEngineInfoDL();
                aSrchEx.setSearchEngine(searchEngine);
                aSrchEx.setSearchIndex(searchIndex);
                aSrchEx.setSearchInfo(searchInfo);
                axdo.setExtension("DKSearchEngineInfoDL", (dkExtension)aSrchEx);
                System.out.println("search engine " + searchEngine);
                System.out.println("search index " + searchIndex);
                System.out.println("search info " + searchInfo);
            }
            axdo.add();
            System.out.println("add successfully.....");
            System.out.println("after add partId = " 
                               + ((DKPidXDODL) (axdo.getPidObject())).getPartId());

            System.out.println("after add itemId = " 
                               + ((DKPidXDODL) (axdo.getPidObject())).getPrimaryId());

            System.out.println("about to do retrieve()...");
            axdo.retrieve();

            System.out.println("after retrieve() repType=" + axdo.getRepType()); 
            System.out.println("after retrieve() length=" + axdo.length()); 
            axdo.setInstanceOpenHandler("lviewpro ", true);
            int cc = axdo.getContentClass();
            System.out.println("Content class " + cc);

            dsDL.disconnect();
            System.out.println("datastore disconnected"); 
            dsDL.destroy();
            if (fText == true)
            {
                System.out.println("start indexing for TS"); 
                dsAdminTS.startUpdateIndex(srchIndex);
                System.out.println("indexing started"); 
                dsTS.disconnect();
                System.out.println("disconnect from TS"); 
                dsTS.destroy();
            }
        }
        catch (DKException exc)
        {
     	    try {
             if (dsDL != null)
     	        dsDL.destroy();
     	    }
     	    catch (Exception e)
     	    {
     	     e.printStackTrace();
     	    }      
     	    try {
             if (dsTS != null)
     	        dsTS.destroy();
     	    }
     	    catch (Exception e)
     	    {
     	     e.printStackTrace();
     	    }      
     	    try {
             if (dsQBIC != null)
     	        dsQBIC.destroy();
     	    }
     	    catch (Exception e)
     	    {
     	     e.printStackTrace();
     	    }      
            System.out.println("Exception name " + exc.name());
            System.out.println("Exception message " + exc.getMessage());
            exc.printStackTrace();
        }
        catch (Exception exc)
        {
     	    try {
             if (dsDL != null)
     	        dsDL.destroy();
     	    }
     	    catch (Exception e)
     	    {
     	     e.printStackTrace();
     	    }      
     	    try {
             if (dsTS != null)
     	        dsTS.destroy();
     	    }
     	    catch (Exception e)
     	    {
     	     e.printStackTrace();
     	    }      
     	    try {
             if (dsQBIC != null)
     	        dsQBIC.destroy();
     	    }
     	    catch (Exception e)
     	    {
     	     e.printStackTrace();
     	    }      
            System.out.println("Exception message " + exc.getMessage());
            exc.printStackTrace();
        }
    }

    public static void fullGC()
    {
        Runtime rt = Runtime.getRuntime();
        long isFree = rt.freeMemory();
        long wasFree;
        do 
        {
            wasFree = isFree;
            rt.gc();
            isFree = rt.freeMemory();
        } while (isFree > wasFree);
        rt.runFinalization();
    }
}

